Bug 1361334 - Review Request: rubygem-rails-controller-testing - Extracting `assigns` and `assert_template` from ActionDispatch
Summary: Review Request: rubygem-rails-controller-testing - Extracting `assigns` and `...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jun Aruga
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-07-28 20:59 UTC by František Dvořák
Modified: 2016-08-27 10:44 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-08-27 10:44:47 UTC
jaruga: fedora-review+


Attachments (Terms of Use)

Description František Dvořák 2016-07-28 20:59:20 UTC
Spec URL: http://scientific.zcu.cz/fedora/rubygem-rails-controller-testing-0.1.1-1/rubygem-rails-controller-testing.spec
SRPM URL: http://scientific.zcu.cz/fedora/rubygem-rails-controller-testing-0.1.1-1/rubygem-rails-controller-testing-0.1.1-1.fc26.src.rpm
Description: This gem brings back assigns to your controller tests as well as assert_template to both controller and integration tests.
Fedora Account System Username: valtri

Comment 1 Jun Aruga 2016-08-02 08:45:39 UTC
I will review it!

Comment 2 Jun Aruga 2016-08-03 09:10:56 UTC
Hi,
I reviewed it!
Could you check it?
If you have something to comment, please feel free to comment here.


#1. LICENCE file.

> Source1:        https://raw.githubusercontent.com/rails/rails-controller-testing/master/LICENSE

In the case of gem file that the upstream forget to put the LICENCE,
though I did not put LICENCE file in the spec file.
I think your idea is great to solve this case.

However I think below URL is better.
Because it is exactlly same with the upstream's LICENCE file.
https://github.com/rails/rails-controller-testing/blob/v0.1.0/LICENSE

And it becomes benefitable for you to report this issue (LICENSE file is not included in the gem file) to the upstream.
https://github.com/rails/rails-controller-testing/blob/master/rails-controller-testing.gemspec#L15

They must rename LICENCE file after that. You can simlify your RPM spec file after the upstream's next version up.
Also you can put its URL in the spec file as a comment.

Ref.
http://pkgs.fedoraproject.org/cgit/rpms/rubygem-rails-dom-testing.git/tree/rubygem-rails-dom-testing.spec
> License is not included in the gem file.
> # https://github.com/rails/rails-dom-testing/pull/55


#2. Koji URL

Next time not now, it is good habit to put the result of scratch build.
https://bugzilla.redhat.com/show_bug.cgi?id=1359224
> Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=14979792


#3. files

%files
%doc %{gem_instdir}/README.md

You may use gem2rpm old version.
You do not need to include README.md %files section. as you inlude LICENSE file in it.

Remove below lines from %files, and move to %files doc section.
I want to include below files doc RPM file.

%exclude %{gem_instdir}/test/
%exclude %{gem_instdir}/Rakefile

The reason is we want to reduce the base RPM's file size.
And if it is not ".*" file, want to include doc RPM file.


#3. Add below lines. near "BuildRequires: rubygems-devel".
  You can see the result of latest gem2rpm.

BuildRequires: ruby(release)
BuildRequires: ruby


#4. Remove below line from %description doc.

fedora-review warns for that.
Requires:       %{name} = %{version}-%{release}


#5. Use latest version gem2rpm

Finally latest gem2rpm is covering above these things.
I can suggest you can use master branch of 
https://github.com/fedora-ruby/gem2rpm
, though it is optional.

Its generated template is the collection of our latest trend for the spec file.



# the result of fedora-review

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 36 files have unknown license. Detailed
     output of licensecheck in /home/jaruga/git/fedora-
     packages/review/1361334-rubygem-rails-controller-
     testing/licensecheck.txt
[-]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/gems,
     /usr/share/gems/doc
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
     rails-controller-testing-doc
[x]: Package functions as described.
[x]: Latest version is packaged.
[!]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: When checking ruby code, install the ruby plugin.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-rails-controller-testing-0.1.1-1.fc26.noarch.rpm
          rubygem-rails-controller-testing-doc-0.1.1-1.fc26.noarch.rpm
          rubygem-rails-controller-testing-0.1.1-1.fc26.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
rubygem-rails-controller-testing-doc.noarch: W: invalid-url URL: https://github.com/rails/rails-controller-testing <urlopen error [Errno -2] Name or service not known>
rubygem-rails-controller-testing.noarch: W: invalid-url URL: https://github.com/rails/rails-controller-testing <urlopen error [Errno -2] Name or service not known>
2 packages and 0 specfiles checked; 0 errors, 2 warnings.



Requires
--------
rubygem-rails-controller-testing-doc (rpmlib, GLIBC filtered):
    rubygem-rails-controller-testing

rubygem-rails-controller-testing (rpmlib, GLIBC filtered):
    ruby(rubygems)
    rubygem(actionpack)
    rubygem(actionview)
    rubygem(activesupport)



Provides
--------
rubygem-rails-controller-testing-doc:
    rubygem-rails-controller-testing-doc

rubygem-rails-controller-testing:
    rubygem(rails-controller-testing)
    rubygem-rails-controller-testing



Source checksums
----------------
https://rubygems.org/gems/rails-controller-testing-0.1.1.gem :
  CHECKSUM(SHA256) this package     : 4e597b0f4e8d04a76bd647c1e16dd276103f3adc70074ea0768bd3063fb28f11
  CHECKSUM(SHA256) upstream package : 4e597b0f4e8d04a76bd647c1e16dd276103f3adc70074ea0768bd3063fb28f11
https://raw.githubusercontent.com/rails/rails-controller-testing/master/LICENSE :
  CHECKSUM(SHA256) this package     : 9c33e4bf9e0237d7cdf45f811acaafe4004a78c913fd5d39492fe22095b10290
  CHECKSUM(SHA256) upstream package : 9c33e4bf9e0237d7cdf45f811acaafe4004a78c913fd5d39492fe22095b10290


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1361334
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 Vít Ondruch 2016-08-04 11:29:44 UTC
(In reply to Jun Aruga from comment #2)
> #4. Remove below line from %description doc.
> 
> fedora-review warns for that.
> Requires:       %{name} = %{version}-%{release}

What is the issue here? The line should be there ...

Comment 4 Jun Aruga 2016-08-04 16:19:54 UTC
(In reply to Vít Ondruch from comment #3)
> (In reply to Jun Aruga from comment #2)
> > #4. Remove below line from %description doc.
> > 
> > fedora-review warns for that.
> > Requires:       %{name} = %{version}-%{release}
> 
> What is the issue here? The line should be there ...

Sorry I took my mistake. You are correct

Yes, the line is needed.
I am confused it with
"Provides: rubygem(%{gem_name}) = %{version}" in the main before %description, that is not needed now.

Thank you for your mentioning it, Vit.

Sorry for your confusing,  František Dvořák

Comment 5 František Dvořák 2016-08-08 15:56:11 UTC
Thanks for the reviewing!

(In reply to Jun Aruga from comment #2)
> 
> #1. LICENCE file.
> 

> 
> Ref.
> http://pkgs.fedoraproject.org/cgit/rpms/rubygem-rails-dom-testing.git/tree/
> rubygem-rails-dom-testing.spec
> > License is not included in the gem file.
> > # https://github.com/rails/rails-dom-testing/pull/55
> 

Pull request sent (and merged). It seems it is just a typo in upstream gemspec and it's true it will simplify the spec file.

URL updated, versioned license file is better.

> 
> #2. Koji URL
> 
> Next time not now, it is good habit to put the result of scratch build.
> https://bugzilla.redhat.com/show_bug.cgi?id=1359224
> > Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=14979792
> 

OK (I usually include the link to the build. :-))

> 
> #3. files
> 
> %files
> %doc %{gem_instdir}/README.md
> 
> You may use gem2rpm old version.
> You do not need to include README.md %files section. as you inlude LICENSE
> file in it.
> 
> Remove below lines from %files, and move to %files doc section.
> I want to include below files doc RPM file.
> 
> %exclude %{gem_instdir}/test/
> %exclude %{gem_instdir}/Rakefile
> 
> The reason is we want to reduce the base RPM's file size.
> And if it is not ".*" file, want to include doc RPM file.
> 

OK. I guess this is quite "gray" area: some reviewers even prefer to include README file in the main package. The gem2spec version way may be slightly better here because more packages will probably use that way. :-) Updated.

> 
> #3. Add below lines. near "BuildRequires: rubygems-devel".
>   You can see the result of latest gem2rpm.
> 
> BuildRequires: ruby(release)
> BuildRequires: ruby
> 

Why is that needed? Guideline doesn't mention it (most of my ruby packages doesn't have these dependencies).

Although it's true I haven't checked any other ruby implementations here.

> 
> #5. Use latest version gem2rpm
> 
> Finally latest gem2rpm is covering above these things.
> I can suggest you can use master branch of 
> https://github.com/fedora-ruby/gem2rpm
> , though it is optional.
> 
> Its generated template is the collection of our latest trend for the spec
> file.
> 

Yes, it looks like there are no differences in generated spec-file between the version I use (0.11.3) and the master branch.

I generate the spec file by gem2spec, but edit it heavily after that.


Updated package (koji http://koji.fedoraproject.org/koji/taskinfo?taskID=15175903):

Spec URL: http://scientific.zcu.cz/fedora/rubygem-rails-controller-testing-0.1.1-2/rubygem-rails-controller-testing.spec
SRPM URL: http://scientific.zcu.cz/fedora/rubygem-rails-controller-testing-0.1.1-2/rubygem-rails-controller-testing-0.1.1-2.fc25.src.rpm

%changelog
* Mon Aug 08 2016 František Dvořák <valtri@civ.zcu.cz> - 0.1.1-2
- Pull request to include LICENSE file in the gem
- Keep the tests in -doc subpackage

Comment 6 Jun Aruga 2016-08-08 16:37:02 UTC
Hi,  František Dvořák
Just moment. Tomorrow I will reply for your comment here.

Comment 7 Jun Aruga 2016-08-09 12:18:17 UTC
(In reply to František Dvořák from comment #5)

> > #1. LICENCE file.
> 
> Pull request sent (and merged). It seems it is just a typo in upstream
> gemspec and it's true it will simplify the spec file.
> 
> URL updated, versioned license file is better.

Okay I got it, and checked your new spec file.
It looks good to me. Thanks.

> > #2. Koji URL
> > 
> > Next time not now, it is good habit to put the result of scratch build.
> > https://bugzilla.redhat.com/show_bug.cgi?id=1359224
> > > Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=14979792
> > 
> 
> OK (I usually include the link to the build. :-))

OK :)

> > #3. files
> > 
> > %files
> > %doc %{gem_instdir}/README.md
> > 
> > You may use gem2rpm old version.
> > You do not need to include README.md %files section. as you inlude LICENSE
> > file in it.
> > 
> > Remove below lines from %files, and move to %files doc section.
> > I want to include below files doc RPM file.
> > 
> > %exclude %{gem_instdir}/test/
> > %exclude %{gem_instdir}/Rakefile
> > 
> > The reason is we want to reduce the base RPM's file size.
> > And if it is not ".*" file, want to include doc RPM file.
> > 
> 
> OK. I guess this is quite "gray" area: some reviewers even prefer to include
> README file in the main package. The gem2spec version way may be slightly
> better here because more packages will probably use that way. :-) Updated.

Yeah, some reviewers may prefer to include README file.
It is grey area, as it is not written on "Packaging:Ruby" Guideline.
You can decide it of cource finally.
OK I checked it had updated in the new spec file.
Thanks.

> > #3. Add below lines. near "BuildRequires: rubygems-devel".
> >   You can see the result of latest gem2rpm.
> > 
> > BuildRequires: ruby(release)
> > BuildRequires: ruby
> > 
> 
> Why is that needed? Guideline doesn't mention it (most of my ruby packages
> doesn't have these dependencies).
> 
> Although it's true I haven't checked any other ruby implementations here.

We can build and install without these 2 lines on latest version Fedora.
Because these 2 lines are needed to build, install on older Feodra version like F22 or F23. Though I do not know exact version for that. I have heard it.
However it is gray area. It is up to you finally.

> > #5. Use latest version gem2rpm
> > 
> > Finally latest gem2rpm is covering above these things.
> > I can suggest you can use master branch of 
> > https://github.com/fedora-ruby/gem2rpm
> > , though it is optional.
> > 
> > Its generated template is the collection of our latest trend for the spec
> > file.
> > 
> 
> Yes, it looks like there are no differences in generated spec-file between
> the version I use (0.11.3) and the master branch.
> 
> I generate the spec file by gem2spec, but edit it heavily after that.

Yes mostly same. There is a little different. But it looks harmless.
https://github.com/fedora-ruby/gem2rpm/issues/87

> Updated package (koji
> http://koji.fedoraproject.org/koji/taskinfo?taskID=15175903):
> 
> Spec URL:
> http://scientific.zcu.cz/fedora/rubygem-rails-controller-testing-0.1.1-2/
> rubygem-rails-controller-testing.spec
> SRPM URL:
> http://scientific.zcu.cz/fedora/rubygem-rails-controller-testing-0.1.1-2/
> rubygem-rails-controller-testing-0.1.1-2.fc25.src.rpm
> 
> %changelog
> * Mon Aug 08 2016 František Dvořák <valtri@civ.zcu.cz> - 0.1.1-2
> - Pull request to include LICENSE file in the gem
> - Keep the tests in -doc subpackage

I APPROVED your code!

Comment 8 Gwyn Ciesla 2016-08-09 15:35:25 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/rubygem-rails-controller-testing

Comment 9 Fedora Update System 2016-08-09 18:24:35 UTC
rubygem-rails-controller-testing-0.1.1-2.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-d27f6ff494

Comment 10 Fedora Update System 2016-08-10 04:57:06 UTC
rubygem-rails-controller-testing-0.1.1-2.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-d27f6ff494

Comment 11 Fedora Update System 2016-08-27 10:44:44 UTC
rubygem-rails-controller-testing-0.1.1-2.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.